#!/usr/bin/perl
# 
# library - pict
# == scripted by Takuya Otani ========
# == copyright (C) SimpleBoxes 2004 ==

{
	my $aVersion_ = 0.04;
	# ver 0.00 [2003/09/20] 
	# ver 0.01 [2003/10/07] С褦
	# ver 0.02 [2003/11/18] sbpict_size ˤƳĥ̤б
	# ver 0.03 [2004/05/25] sbpict_creat_thumb ɲ
	# ver 0.04 [2004/05/27] sbpict_picttail ɲ / sbpict_size ͤ㴳ѹ
}

sub sbpict_size { # referece from KENT WEB
	my ($file,$tail,$max_w,$max_h) = @_; # ϥѥ᡼
	my ($wid,$hig) = (0,0);              # ϥѥ᡼
	$tail = &sbpict_picttail($file) if (!$tail);
	($wid,$hig) = &sbjpg_size($file) if ($tail eq '.jpg');
	($wid,$hig) = &sbgif_size($file) if ($tail eq '.gif');
	($wid,$hig) = &sbpng_size($file) if ($tail eq '.png');
	if ($max_h and $max_w) {
		if (($wid > $max_w)||($hig > $max_h)) { # ̾γ
			my $tmp = (($max_w / $wid)<($max_h / $hig)) ? $max_w / $wid : $max_h / $hig;
			$wid = int($wid * $tmp) || 1;
			$hig = int($hig * $tmp) || 1;
		}
	}
	return($wid,$hig);
}
sub sbpict_picttail {
	my $file = shift;
	my $tail = '';
	$tail = ".gif" if ($file =~ /\.gif$/i);
	$tail = ".jpg" if ($file =~ /\.jpe?g$/i);
	$tail = ".png" if ($file =~ /\.png$/i);
	return($tail);
}
sub sbpict_creat_thumb {
	my ($thumb,$file,$dir,$size) = @_;
	return() if ($file eq '' or $thumb eq '' or $dir eq '');
	if ( eval('require Image::Magick') ) {
		my ($old,$new) = ();
		$old = Image::Magick->new;
		$old->Read($dir . $file);
		$new = $old->Clone();
		$new->[x]->Scale($size) if ($size);
		$new->Write("$dir$thumb");
	}
	return();
}
sub sbjpg_size { # reference from KENT WEB
	my($jpeg) = @_;
	my($t, $m, $c, $l, $W, $H);
	open(JPEG, "$jpeg") || return (0,0);
	binmode JPEG;
	read(JPEG, $t, 2);
	while (1) {
		read(JPEG, $t, 4);
		($m, $c, $l) = unpack("a a n", $t);
		if ($m ne "\xFF") { $W = $H = 0; last; }
		elsif ((ord($c) >= 0xC0) && (ord($c) <= 0xC3)) {
			read(JPEG, $t, 5);
			($H, $W) = unpack("xnn", $t);
			last;
		}
		else {
			read(JPEG, $t, ($l - 2));
		}
	}
	close(JPEG);
	return ($W, $H);
}
sub sbgif_size { # reference from KENT WEB
	my($gif) = @_;
	my($data);
	open(GIF,"$gif") || return (0,0);
	binmode(GIF);
	sysread(GIF,$data,10);
	close(GIF);
	if ($data =~ /^GIF/) { $data = substr($data,-4); }
	$W = unpack("v",substr($data,0,2));
	$H = unpack("v",substr($data,2,2));
	return ($W, $H);
}
sub sbpng_size { # WWWis (http://www.bloodyeck.com/wwwis/) 
	my($png) = @_;
	my($head, $a, $b, $c, $d, $e, $f, $g, $h);
	open(PNG,"$png") || return (0,0);
	binmode(PNG);
	if (defined(PNG) && read(PNG, $head, 8) == 8 &&
		$head eq "\x89\x50\x4e\x47\x0d\x0a\x1a\x0a" &&
		read(PNG, $head, 4) == 4 && read(PNG, $head, 4) == 4 &&
		$head eq "IHDR" && read(PNG, $head, 8) == 8) {
		($a,$b,$c,$d,$e,$f,$g,$h) = unpack("C"x8, $head);
	}
	else { return (0,0); }
	close(PNG);
	return ($a<<24|$b<<16|$c<<8|$d, $e<<24|$f<<16|$g<<8|$h);
}
1;
