function confirmDelete() {
	var selNum = checkSelectedItems();
	if (selNum == 0) {
		alert('No item is selected.');
		return false;
	}
	if ( window.confirm('Are you sure you want to delete selected items?') ) {
		return true;
	} else {
		return false;
	}
}
function confirmDeleteTarget(objTarget) {
	var selNum = 0;
	if (!objTarget) return false;
	for (var i=0;i<objTarget.elements.length;i++) {
		if (objTarget.elements[i].name == 'sel') {
			var obj = objTarget.elements[i];
			if (obj.checked) selNum++;
		}
	}
	if (selNum == 0) {
		alert('No item is selected.');
		return false;
	}
	if ( window.confirm('Are you sure you want to delete selected items?') ) {
		return true;
	} else {
		return false;
	}
}
function confirmAction() {
	var selNum = checkSelectedItems();
	var flag = checkAction();
	if (selNum == 0) {
		alert('No item is selected.');
		return false;
	}
	if (!flag) {
		alert('No action is selected.');
		return false;
	}
	if ( window.confirm('Are you sure you want to make an action for selected items?') ) {
		return true;
	} else {
		return false;
	}
}
function checkSelectedItems() {
	if (document.listform) {
		var selNum = 0;
		for (var i=0;i<document.listform.elements.length;i++) {
			if (document.listform.elements[i].name == 'sel') {
				var obj = document.listform.elements[i];
				if (obj.checked) selNum++;
			}
			if (document.listform.elements[i].name == 'id') {
				var obj = document.listform.elements[i];
				if (obj.value != null) selNum++;
			}
		}
		return(selNum);
	} else {
		return(1);
	}
}
function checkAction() {
	var obj = this.document.getElementById('regi_action');
	if (!obj) return true;
	if (obj.value == '') return false;
	return true;
}
function changeHeight(idName, direction) {
	var max = 99;
	var min = 3;
	var obj = this.document.getElementById(idName);
	if (!obj) return false;
	var row = parseInt(obj.getAttribute("rows"));
	if (row > 0) {
		row = row + ( direction * 2);
		if (row < min) row = min;
		if (row > max) row = max;
		obj.setAttribute("rows", row);
		if (window.navigator.userAgent.indexOf('AppleWebKit') > -1) {
			var height = row * 1.1;
			obj.style.height = Array(height,'em').join('');
		}
	}
	return false;
}
function replaceEntity(str) {
	str = str.split("&").join("&amp;");
	str = str.split("<").join("&lt;");
	str = str.split(">").join("&gt;");
	str = str.split('"').join("&quot;");
	return(str);
}
function reverseEntity(str) {
	str = str.split("&quot;").join('"');
	str = str.split("&gt;").join(">");
	str = str.split("&lt;").join("<");
	str = str.split("&amp;").join("&");
	return(str);
}
function changeEntity(idName, mode) {
	var obj = this.document.getElementById(idName);
	if (!obj) return false;
	var txtConfirm = (mode) ? 'convert all charcters to entities in textarea.' : 'convert all entities to normal characters in texarea.';
	txtConfirm = Array(txtConfirm,"\n\nAre you sure?").join('');
	if (document.selection) {
		obj.focus();
		var str = document.selection.createRange().text;
		if (str) {
			document.selection.createRange().text = (mode) ? replaceEntity(str) : reverseEntity(str);
		} else if (obj.value && confirm(txtConfirm)) {
			obj.value = (mode) ? replaceEntity(obj.value) : reverseEntity(obj.value);
		}
	} else if ( (obj.selectionEnd - obj.selectionStart) > 0 ) {
		var bgnPos = obj.selectionStart;
		var endPos = obj.selectionEnd;
		var bfrStr = obj.value.substring(0, bgnPos);
		var fcsStr = (mode) ? replaceEntity(obj.value.substring(bgnPos, endPos)) : reverseEntity(obj.value.substring(bgnPos, endPos));
		var difLen = fcsStr.length - (endPos - bgnPos);
		var aftStr = obj.value.substring(endPos, obj.value.length);
		obj.value = Array(bfrStr,fcsStr,aftStr).join('');
		obj.setSelectionRange(bgnPos,endPos + difLen);
	} else if (obj.value) {
		if (confirm(txtConfirm)) {
			obj.value = (mode) ? replaceEntity(obj.value) : reverseEntity(obj.value);
		}
	}
	return false;
}
function addHtmlTag(idName, tag, option) {
	var obj = this.document.getElementById(idName);
	if (!obj) return false;
	var bgnTag = (!option) ? Array('<',tag,'>').join('') : Array('<',tag,' ',option,'>').join('');
	var endTag = Array('</',tag,'>').join('');
	if (document.selection) {
		obj.focus();
		var str = document.selection.createRange().text;
		document.selection.createRange().text = Array(bgnTag,str,endTag).join('');
	} else if ( (obj.selectionEnd - obj.selectionStart) >= 0 ) {
		var bgnPos = obj.selectionStart;
		var endPos = obj.selectionEnd;
		var bfrStr = obj.value.substring(0, bgnPos);
		var fcsStr = Array(bgnTag,obj.value.substring(bgnPos, endPos),endTag).join('');
		var difLen = fcsStr.length - (endPos - bgnPos);
		var aftStr = obj.value.substring(endPos, obj.value.length);
		obj.value = Array(bfrStr,fcsStr,aftStr).join('');
		obj.setSelectionRange(bgnPos,endPos + difLen);
	} else {
		obj.value = Array(obj.value,bgnTag,endTag).join('');
	}
	return false;
}
function addLink(idName) {
	var url = prompt('Please input URL to link', 'http://');
	if (url == null) return false;
	var option = Array('href="',url,'" target="_blank"').join('');
	addHtmlTag(idName, 'a', option);
}
function addImage(idName,val) {
	var obj = this.document.getElementById(idName);
	if (!obj) return false;
	if (val == '') return false;
	if (document.selection) {
		obj.focus();
		var str = document.selection.createRange().text;
		if (!str) {
			document.selection.createRange().text = Array('<img ',val,' />').join('');
		} else {
			obj.value = Array(obj.value,'<img ',val,' />').join('');
		}
	} else if ( (obj.selectionEnd - obj.selectionStart) == 0 ) {
		var bgnPos = obj.selectionStart;
		var endPos = obj.selectionEnd;
		var bfrStr = obj.value.substring(0, bgnPos);
		var fcsStr = Array('<img ',val,' />').join('');
		var difLen = fcsStr.length;
		var aftStr = obj.value.substring(endPos, obj.value.length);
		obj.value = Array(bfrStr,fcsStr,aftStr).join('');
		obj.setSelectionRange(bgnPos,endPos + difLen);
	} else {
		obj.value = Array(obj.value,'<img ',val,' />').join('');
	}
	return false;
}
function switchAll(obj) {
	if (obj.checked) {
		selectAllList();
	} else {
		clearAllList();
	}
}
function switchAllTarget(obj,objTarget) {
	if (obj.checked) {
		selectAllList(objTarget);
	} else {
		clearAllList(objTarget);
	}
}
function switchList(obj) {
	if (obj.checked) {
		selectList(obj);
	} else {
		clearList(obj);
	}
}
function selectType(str) {
	if (!str) return;
	var num = 0;
	for (var i=0;i<document.listform.elements.length;i++) {
		if (document.listform.elements[i].name == 'sel') {
			var obj = document.listform.elements[i];
			var parentObj = null;
			if (obj.parentNode) {
				parentObj = obj.parentNode;
			} else if (obj.parentElement) {
				parentObj = obj.parentElement;
			}
			if (parentObj) {
				if (parentObj.className.indexOf(str) > -1) {
					num++;
					selectList(obj);
				} else {
					clearList(obj);
				}
			}
		}
	}
	var obj = this.document.getElementById('showSelected');
	if (obj) obj.innerHTML = num;
}
function selectAllList(objList) {
	if (!objList) objList = document.listform
	if (!objList) return;
	for (var i=0;i < objList.elements.length;i++) {
		if (objList.elements[i].name == 'sel') {
			selectList(objList.elements[i]);
		}
	}
	objList.selectAll.checked = true;
}
function clearAllList(objList) {
	if (!objList) objList = document.listform
	if (!objList) return;
	for (var i=0;i < objList.elements.length;i++) {
		if (objList.elements[i].name == 'sel') {
			clearList(objList.elements[i]);
		}
	}
	objList.selectAll.checked = false;
	if (objList.typeselect) document.listform.typeselect.selectedIndex = 0;
}
function selectList(obj) {
	obj.checked = true;
	var parentObj = null;
	if (obj.parentNode && obj.parentNode.parentNode && obj.parentNode.parentNode.parentNode) {
		parentObj = obj.parentNode.parentNode.parentNode;
	} else if (obj.parentElement && obj.parentElement.parentElement && obj.parentElement.parentElement.parentElement) {
		parentObj = obj.parentElement.parentElement.parentElement;
	}
	if (parentObj) {
		if (parentObj.className == 'odd') {
			parentObj.className = 'selected_odd';
		} else if (parentObj.className == 'even') {
			parentObj.className = 'selected_even';
		}
	}
	displaySelectedNumber(+1);
}
function clearList(obj) {
	obj.checked = false;
	var parantObj = null;
	if (obj.parentNode && obj.parentNode.parentNode && obj.parentNode.parentNode.parentNode) {
		parantObj = obj.parentNode.parentNode.parentNode;
	} else if (obj.parentElement && obj.parentElement.parentElement && obj.parentElement.parentElement.parentElement) {
		parantObj = obj.parentElement.parentElement.parentElement;
	}
	if (parantObj) {
		if (parantObj.className == 'selected_odd') {
			parantObj.className = 'odd';
		} else if (parantObj.className == 'selected_even') {
			parantObj.className = 'even';
		}
	}
	displaySelectedNumber(-1);
}
function displaySelectedNumber(diff) {
	var obj = this.document.getElementById('showSelected');
	if (obj) {
		var selNum = parseInt(obj.innerHTML);
		selNum = selNum + diff;
		if (selNum < 0) selNum = 0;
		obj.innerHTML = selNum;
	}
}
function showForm(idName) {
	var obj = this.document.getElementById(idName);
	if (!obj) return false;
	obj.style.display = 'block';
	window.location.hash = idName;
	var objForm = this.document.getElementById('upload_file');
	if (!objForm) return;
	objForm.focus();
	return;
}
function setNowTime() {
	var nowTime = new Date();
	var yr = nowTime.getYear();
	var mo = nowTime.getMonth()+1;
	var dy = nowTime.getDate();
	var ho = nowTime.getHours();
	var mi = nowTime.getMinutes();
	var sc = nowTime.getSeconds();
	var form = document.mainform;
	form.entry_date_yr.value = (yr < 2000) ? yr + 1900 : yr;
	form.entry_date_mo.value = (mo < 10) ? '0' + mo : mo;
	form.entry_date_dy.value = (dy < 10) ? '0' + dy : dy;
	form.entry_date_ho.value = (ho < 10) ? '0' + ho : ho;
	form.entry_date_mi.value = (mi < 10) ? '0' + mi : mi;
	form.entry_date_sc.value = (sc < 10) ? '0' + sc : sc;
	return;
}
function sbit(txt_subj,txt_url,txt_body) {
	if (txt_subj.length > 0) {
		var obj = this.document.getElementById('entry_title');
		txt_subj = txt_subj.split("\n").join("");
		obj.value = Array('Re: ',unescape(txt_subj)).join('');
	}
	if (txt_body.length > 0) {
		var obj = this.document.getElementById('entry_body');
		obj.value = Array(obj.value,'<blockquote><p>',unescape(txt_body),'</p></blockquote>').join('');
	}
	if (txt_url.length > 0 && txt_subj.length > 0) {
		var obj = this.document.getElementById('entry_body');
		obj.value = Array(obj.value,'<p class="source"><cite><a href="',unescape(txt_url),'">',unescape(txt_subj),'</a></cite></p>\n').join('');
	}
}
